<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeriesVendasERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeriesVendasERP
 * @subpackage Arrays
 */
class ArrayOfSeriesVendasERP extends AbstractStructArrayBase
{
    /**
     * The SeriesVendasERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeriesVendasERP[]
     */
    public $SeriesVendasERP;
    /**
     * Constructor method for ArrayOfSeriesVendasERP
     * @uses ArrayOfSeriesVendasERP::setSeriesVendasERP()
     * @param \StructType\SeriesVendasERP[] $seriesVendasERP
     */
    public function __construct(array $seriesVendasERP = array())
    {
        $this
            ->setSeriesVendasERP($seriesVendasERP);
    }
    /**
     * Get SeriesVendasERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeriesVendasERP[]|null
     */
    public function getSeriesVendasERP()
    {
        return isset($this->SeriesVendasERP) ? $this->SeriesVendasERP : null;
    }
    /**
     * Set SeriesVendasERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesVendasERP[] $seriesVendasERP
     * @return \ArrayType\ArrayOfSeriesVendasERP
     */
    public function setSeriesVendasERP(array $seriesVendasERP = array())
    {
        foreach ($seriesVendasERP as $arrayOfSeriesVendasERPSeriesVendasERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeriesVendasERPSeriesVendasERPItem instanceof \StructType\SeriesVendasERP) {
                throw new \InvalidArgumentException(sprintf('The SeriesVendasERP property can only contain items of \StructType\SeriesVendasERP, "%s" given', is_object($arrayOfSeriesVendasERPSeriesVendasERPItem) ? get_class($arrayOfSeriesVendasERPSeriesVendasERPItem) : gettype($arrayOfSeriesVendasERPSeriesVendasERPItem)), __LINE__);
            }
        }
        if (is_null($seriesVendasERP) || (is_array($seriesVendasERP) && empty($seriesVendasERP))) {
            unset($this->SeriesVendasERP);
        } else {
            $this->SeriesVendasERP = $seriesVendasERP;
        }
        return $this;
    }
    /**
     * Add item to SeriesVendasERP value
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesVendasERP $item
     * @return \ArrayType\ArrayOfSeriesVendasERP
     */
    public function addToSeriesVendasERP(\StructType\SeriesVendasERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeriesVendasERP) {
            throw new \InvalidArgumentException(sprintf('The SeriesVendasERP property can only contain items of \StructType\SeriesVendasERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SeriesVendasERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeriesVendasERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeriesVendasERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeriesVendasERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeriesVendasERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeriesVendasERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeriesVendasERP
     */
    public function getAttributeName()
    {
        return 'SeriesVendasERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSeriesVendasERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
